package com.its.op.service.its.rse;

import com.its.op.dao.repository.its.rse.TbRseSectTrafHsRepository;
import com.its.op.dto.its.rse.TbRseCtlrCnncHsDto;
import com.its.op.dto.its.rse.TbRseSectTrafHsDto;
import com.its.op.entity.its.rse.TbRseCtlrCnncHs;
import com.its.op.entity.its.rse.TbRseSectTrafHs;
import com.its.op.entity.its.rse.TbRseSectTrafHsKey;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.NoSuchElementException;
import java.util.Optional;

@Slf4j
@RequiredArgsConstructor
@Service
public class TbRseSectTrafHsService {

    private final TbRseSectTrafHsRepository repo;

    // 데이터 1건 조회, 없으면 exception
    private TbRseSectTrafHs requireOne(TbRseSectTrafHsKey id) throws NoSuchElementException {
        Optional<TbRseSectTrafHs> info = this.repo.findById(id);
        if (info.isPresent()) {
            return info.get();
        }
        else {
            throw new NoSuchElementException("데이터가 존재하지 않습니다: " + id);
        }
//        return this.repo.findById(id)
//                .orElseThrow(() -> new NoSuchElementException("데이터가 존재하지 않습니다: " + id));
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbRseSectTrafHsDto> findAll() {
        List<TbRseSectTrafHsDto> result = new ArrayList<>();
        List<TbRseSectTrafHs> data = this.repo.findAll();
        for (TbRseSectTrafHs entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    public List<TbRseSectTrafHsDto> findAllByDateRange(String fromDt, String toDt, List<Long> ids) {
        List<TbRseSectTrafHsDto> result = new ArrayList<>();
        List<TbRseSectTrafHs> data = this.repo.findAllByDateRange(fromDt, toDt, ids);
        if (data != null) {
            data.forEach(obj -> {
                result.add(obj.toDto());
            });
        }
        return result;
    }
}
